package com.xy.service;

import cn.dev33.satoken.stp.StpUtil;
import com.xy.dto.LoginDto;
import com.xy.dto.SatokenAuthorizeDto;
import com.xy.satoken.SaTokenAuthorize;
import com.xy.satoken.SaTokenAuthorizeConfig;
import com.xy.utils.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@Service
@AllArgsConstructor
@Api(tags = "权限校验")
public class AuthorizeServiceImpl implements AuthorizeService {

    private SaTokenAuthorize saTokenAuthorize;

    private SaTokenAuthorizeConfig saTokenAuthorizeConfig;

    @Override
    @ApiOperation("微服务鉴权")
    public R<Boolean> satokenAuthorize(@RequestBody SatokenAuthorizeDto satokenAuthorizeDto) {
        List<String> excludePaths = saTokenAuthorizeConfig.getExcludePaths();
        String permission = satokenAuthorizeDto.getPermission();
        if (excludePaths.contains(permission)) {
            return R.ok(true);
        }
        boolean check = saTokenAuthorize.check(satokenAuthorizeDto.getSatoken(), permission);
        return R.ok(check);
    }

    @Override
    @ApiOperation("登录")
    public R<String> login(@RequestBody LoginDto loginDto) {
        StpUtil.login(loginDto.getAccount());
        return R.ok(StpUtil.getTokenValue());
    }

}
